import cv2

from utils import *
from darknet import Darknet
from flask import Flask
from flask import request

app = Flask(__name__)

cfg_file = 'cfg/yolov3.cfg'
weight_file = 'weights/yolov3.weights'
namesfile = 'data/coco.names'

m = Darknet(cfg_file)

m.load_weights(weight_file)

class_names = load_class_names(namesfile)

plt.rcParams['figure.figsize'] = [24.0, 14.0]

@app.route("/OpenCV")
def hello():
    filePath = request.args.get('file')

    img = cv2.imread(filePath)

    original_image = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)

    resized_image = cv2.resize(original_image, (m.width, m.height))

    iou_thresh = 0.4

    nms_thresh = 0.6
    boxes = detect_objects(m, resized_image, iou_thresh, nms_thresh)

    return print_objects(boxes, class_names)

if __name__ == '__main__':
    app.run(debug=True, port=5000)